<?php
/* <meta content="charset=UTF-8"> */

class Form extends Controller
{
  // コンストラクター
  function Form() {
    // 親クラスのコンストラクターを実行
    parent::Controller();

    // ヘルパーをロード
    $this->load->helper('url');

    // Formバリデーション（検証）クラスをロード
    $this->load->library('form_validation');

    // 検証ルールの設定
    $this->form_validation->set_rules('name', 'お名前', 'trim|required|max_length[100]');
    $this->form_validation->set_rules('age', '年齢', 'trim|required|integer|max_length[3]');
    $this->form_validation->set_rules('email', 'e-mail', 'trim|required|valid_email');
    $this->form_validation->set_rules('subject', '件名', 'trim|required|max_length[100]');
    $this->form_validation->set_rules('body', '内容', 'trim|required|max_length[500]');
  }

  // 入力ページ
  function index() {
    // 確認ページから戻った場合に入力値を表示するため検証処理を実行
    $this->form_validation->run();
    // ビューを表示
    $this->load->view('form1_view');
  }

  // 確認ページ
  function confirm() {
    // 検証処理を実行
    if ($this->form_validation->run() === FALSE) {
      // エラーがあった場合
      $this->load->view('form1_view');
    } else {
      // 検証をパスした場合
      $this->load->view('form2_view');
    }
  }
}

/* End of file form.php */
/* Location: ./system/application/controllers/form.php */
