<?php
/* <meta content="charset=UTF-8"> */

/*
 * SimpleAPI Wikipedia API
 * 
 */

class Wikipedia extends Controller
{
  function index() {
    // ヘルパーをロード
    $this->load->helper('html', 'security');

    // ライブラリーをロード
    $this->load->library('form_validation');

    // フォームの検証ルールの設定
    $this->form_validation->set_rules('q', 'キーワード', 
                             'checkNull|checkEncoding|max_length[20]');

    // フォームの検証
    if ($this->form_validation->run() === FALSE) {
      $keyword = '';
      $data = array();
    } else {
      // 検索するキーワード
      $keyword = $this->input->post('q');

      // Web APIからデータを取得
      $data = $this->_get($keyword);
    }

    // ビューを表示
    $this->load->view('wikipedia_view', $data);
  }

  function _get($keyword) {
    // Web APIのURIを組み立て
    $keyword = urlencode($keyword);
    $uri = "http://wikipedia.simpleapi.net/api?keyword={$keyword}";

    // GETリクエストのタイムアウト設定（5秒）
    $opts = array('http' =>
                  array('timeout' => 5)
            );
    $context  = stream_context_create($opts);
    // Web APIへリクエスト送信
    $xml = file_get_contents($uri, 0, $context);
    // リクエストが失敗したかチェック
    if ($xml === FALSE) {
      die('Web APIからデータを取得できませんでした');
    }

    // XMLデータをオブジェクトに変換
    $sxml = simplexml_load_string($xml);
    //var_dump($sxml);

    $data = array();

    // 取得データを処理し配列に代入
    foreach ($sxml->result as $item) {
      $result = array();
      $result['url']   = $item->url;
      $result['title'] = $item->title;
      // <br/>タグを改行コードに変換
      $result['body']  = str_replace('<br/>', "\n", $item->body);
      $data['result'][] = $result;
    }

    return $data;
  }
}

/* End of file wikipedia.php */
/* Location: ./system/application/controllers/wikipedia.php */
